unit UPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DBXpress, FMTBcd, Buttons, ExtCtrls, DB, Grids, DBGrids,
  StdCtrls, DBClient, Provider, SqlExpr, InvokeRegistry, Rio,
  SOAPHTTPClient;

type
  TForm1 = class(TForm)
    SQLConnection: TSQLConnection;
    sqlCadastro: TSQLDataSet;
    sqlCadastroCAMPO_PK: TIntegerField;
    sqlCadastroNOME: TStringField;
    sqlCadastroALTERADO: TStringField;
    sqlCadastroHORA: TSQLTimeStampField;
    dspCadastro: TDataSetProvider;
    cdsCadastro: TClientDataSet;
    dtsCadastro: TDataSource;
    Label1: TLabel;
    DBGrid1: TDBGrid;
    cdsCadastroCAMPO_PK: TIntegerField;
    cdsCadastroNOME: TStringField;
    cdsCadastroALTERADO: TStringField;
    cdsCadastroHORA: TSQLTimeStampField;
    Label2: TLabel;
    DBGrid2: TDBGrid;
    cdsDeletados: TClientDataSet;
    dtsDeletados: TDataSource;
    cdsDeletadosDelete: TStringField;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    HTTPRIO: THTTPRIO;
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
    procedure SetAtualizado;
    procedure ClearDeleteFile;
    procedure Enviar;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses UIwsAtualizar;

{$R *.dfm}

{ TForm1 }

procedure TForm1.ClearDeleteFile;
begin
  cdsDeletados.EmptyDataSet;
end;

procedure TForm1.Enviar;
var
  ld_AData: OleVariant;
  ld_DData: OleVariant;
begin
  // Atribui o valor atual da variavel data
  ld_AData := cdsCadastro.Data;
  ld_DData := cdsDeletados.Data;
  // Para voltar o data ao cds
  try
    // E passada uma variavel, pq nao aceita passar direto a propriedade Data
    (HTTPRIO as IwsAtualizar).Atualiza(ld_AData);
    (HTTPRIO as IwsAtualizar).Delete(ld_DData);
  finally
    // Fecha os DataSet
    cdsCadastro.Close;
    cdsDeletados.Close;
    cdsCadastro.ProviderName := '';

    cdsCadastro.Data := Null;
    cdsDeletados.Data := Null;

    // Atribui o valor retornado do WebService
    cdsCadastro.Data := ld_AData;
    cdsDeletados.Data := ld_DData;
  end;
end;

procedure TForm1.SetAtualizado;
var
  ls_Codigo: String;
  ls_SQL: String;
begin
  // Marca todos os registros que esto marcados como alterados para "N"
  with cdsCadastro do
  begin
    if not active then open;
    First;
    ls_Codigo := '';
    while not EOF do
    begin
      ls_Codigo := ls_Codigo + cdsCadastroCAMPO_PK.AsString +',';
      Next;
    end;
    ls_Codigo := Copy(ls_Codigo,1,Length(ls_Codigo) - 1);
  end;
  ls_SQL :=
    'update TESTE set '+
    ' alterado = ''N'' '+
    'where alterado = ''S'' ';
  if Length(Trim(ls_Codigo)) > 0 then
    ls_SQL := ls_SQL +
      '  and CAMPO_PK NOT IN('+ ls_Codigo +')';
  SQLConnection.ExecuteDirect(ls_SQL);
  cdsCadastro.Close;
  cdsCadastro.Open;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  cdsCadastro.Close;
  cdsCadastro.ProviderName := 'dspCadastro';
  cdsCadastro.Open;
  cdsDeletados.Close;
  cdsDeletados.Open;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Enviar;
  SetAtualizado;
  ClearDeleteFile;
end;

end.
