unit Service;

interface
uses

  System.ServiceProcess;


type
  TServiceExemple = class(System.ServiceProcess.ServiceBase)
  strict protected
    procedure OnStart(args: array of string); override;
    procedure OnPause; override;
    procedure OnStop; override;
    procedure OnContinue; override;
    procedure OnShutdown; override;
  public
    constructor Create;
  end;

var
  MyServiceExemple: TServiceExemple = nil;

implementation

uses
  ProjectInstaller, System.Windows.Forms;

{ TWindowsService }

constructor TServiceExemple.Create;
begin
  inherited Create;

  ServiceName := DefaultServiceName;

  CanHandlePowerEvent := False;
  CanPauseAndContinue := True;
  CanShutdown := True;
  CanStop := True;

  EventLog.Source := DefaultServiceName;
  EventLog.Log := ''; //ToDo: set your custom log or leave it blank for defaults

  AutoLog := True;
end;

procedure TServiceExemple.OnStart(args: array of string);
begin
  inherited;
  MessageBox.Show('Servio iniciado.')
  //ToDo: add your code here
end;

procedure TServiceExemple.OnPause;
begin
  inherited;

  //ToDo: add your code here
end;

procedure TServiceExemple.OnStop;
begin
  inherited;

  //ToDo: add your code here
end;

procedure TServiceExemple.OnContinue;
begin
  inherited;

  //ToDo: add your code here
end;

procedure TServiceExemple.OnShutdown;
begin
  inherited;

  //ToDo: add your code here
end;

end.
