unit uMainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdExplicitTLSClientServerBase, IdMessageClient, IdSMTPBase, IdSMTP, StdCtrls,
  Menus, IdMessage, ExtCtrls;

type
  TForm1 = class(TForm)
    IdSMTP: TIdSMTP;
    IdMessage: TIdMessage;
    Panel1: TPanel;
    btnEnviar: TButton;
    btnFechar: TButton;
    GroupBox1: TGroupBox;
    edtHost: TEdit;
    Label1: TLabel;
    edtSenha: TEdit;
    edtPorta: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    edtUsuario: TEdit;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    edtPara: TEdit;
    Label8: TLabel;
    memCorpoEmail: TMemo;
    edtDe: TEdit;
    edtAssunto: TEdit;
    cbPrioridade: TComboBox;
    Label9: TLabel;
    Label10: TLabel;
    edtExibicao: TEdit;
    procedure btnFecharClick(Sender: TObject);
    procedure btnEnviarClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnEnviarClick(Sender: TObject);
begin
  (* Configurando o componente SMTP *)
  IdSMTP.Host := edtHost.Text;
  IdSMTP.Username := edtUsuario.Text;
  IdSMTP.Password := edtSenha.Text;

  try
    IdSMTP.Port := StrToInt(edtPorta.Text);
  except
    on E: EConvertError do
    begin
      ShowMessage('Valor informado para porta de email invlido!');
      edtPorta.SetFocus;
      Exit;
    end;
  end;

  try
    IdSMTP.Connect;
  except
    ShowMessage('Erro ao se conectar ao servidor de email.'+#13#10+
                'Verifique a configurao do programa.');
    IdSMTP.Disconnect;
    Exit;
  end;

  (* Configurando o componente de composio dos parametros da mensagem
     do email *)
  IdMessage.Body.Assign( memCorpoEmail.Lines );
  //IdMessage.From.DisplayName := edtExibicao.Text;
  IdMessage.From.Address := edtDe.Text;
  IdMessage.Priority := TIdMessagePriority(cbPrioridade.ItemIndex);
  IdMessage.Subject := edtAssunto.Text;
  IdMessage.Recipients.EMailAddresses := edtPara.Text;

  try
    // tentando enviar o email.
    IdSMTP.Send(IdMessage);
    IdSMTP.Disconnect;
  except
    on E: Exception do
      ShowMessage('Erro ao mandar email. Causa: ' + E.Message);
  end;

  ShowMessage('Email enviado com sucesso !');
end;

procedure TForm1.btnFecharClick(Sender: TObject);
begin
  Close;
end;

end.
